package com.engine.salary.mapper.datacollection;

import com.engine.salary.entity.datacollection.dto.AttendQuoteFieldListDTO;
import com.engine.salary.entity.datacollection.param.AttendQuoteFieldQueryParam;
import com.engine.salary.entity.datacollection.po.AttendQuoteFieldPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

public interface AttendQuoteFieldMapper {

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<AttendQuoteFieldPO> listAll();


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    AttendQuoteFieldPO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param AttendQuoteFieldPO 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(AttendQuoteFieldPO AttendQuoteFieldPO);

    /**
     * 修改，修改所有字段
     *
     * @param AttendQuoteFieldPO 修改的记录
     * @return 返回影响行数
     */
    int update(AttendQuoteFieldPO AttendQuoteFieldPO);

    /**
     * 修改，忽略null字段
     *
     * @param AttendQuoteFieldPO 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(AttendQuoteFieldPO AttendQuoteFieldPO);

    /**
     * 删除记录
     *
     * @param AttendQuoteFieldPO 待删除的记录
     * @return 返回影响行数
     */
    int delete(AttendQuoteFieldPO AttendQuoteFieldPO);

    /**
     * 删除考勤的字段
     *
     * @param param
     * @return
     */
    int deleteAttendByCode(@Param("param") AttendQuoteFieldQueryParam param);


    /**
     * 查询数据采集-考勤引用字段列表
     *
     * @param param
     * @return
     */
    List<AttendQuoteFieldListDTO> list(@Param("param") AttendQuoteFieldQueryParam param);


    /**
     * 批量删除数据采集-考勤引用字段
     *
     * @param ids
     */
    void deleteByIds(@Param("ids") Collection<Long> ids);

    /**
     * 插入
     *
     * @param saves
     */
    void saveBatch(@Param("saves") List<AttendQuoteFieldPO> saves);

    /**
     * 更新字段名
     *
     * @param updates
     */
    void updateNameByCode(@Param("updates") List<AttendQuoteFieldPO> updates);

    /**
     * 条件查询
     *
     * @param param
     * @return
     */
    List<AttendQuoteFieldPO> listSome(@Param("param") AttendQuoteFieldPO param);
}